Package org.apache.tomcat.util.net.openssl

# Class OpenSSLUtil

java.lang.Object
org.apache.tomcat.util.net.SSLUtilBase
org.apache.tomcat.util.net.openssl.OpenSSLUtil

All Implemented Interfaces:
  `SSLUtil`

public class OpenSSLUtil extends SSLUtilBase

## Nested Class Summary

### Nested classes/interfaces inherited from interface org.apache.tomcat.util.net.SSLUtil

`SSLUtil.ProtocolInfo`

## Field Summary

### Fields inherited from class org.apache.tomcat.util.net.SSLUtilBase

`certificate, DEFAULT_KEY_ALIAS, sslHostConfig`

## Constructor Summary

Constructors
Constructor
Description
`OpenSSLUtil(SSLHostConfigCertificate certificate)`

## Method Summary

Modifier and Type
Method
Description
`static X509KeyManager`
`chooseKeyManager(KeyManager[] managers, boolean throwOnMissing)`
`SSLContext`
`createSSLContextInternal(List<String> negotiableProtocols)`
`protected Set<String>`
`getImplementedCiphers()`
`protected Set<String>`
`getImplementedProtocols()`
`KeyManager[]`
`getKeyManagers()`
`protected Log`
`getLog()`
`protected boolean`
`isTls13RenegAuthAvailable()`

### Methods inherited from class org.apache.tomcat.util.net.SSLUtilBase

`configureSessionContext, createSSLContext, getCRLs, getEnabledCiphers, getEnabledProtocols, getParameters, getTrustManagers`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### OpenSSLUtil

public OpenSSLUtil(SSLHostConfigCertificate certificate)

## Method Details

### getLog

protected Log getLog()

Specified by:
  `getLog` in class `SSLUtilBase`

### getImplementedProtocols

protected Set<String> getImplementedProtocols()

Specified by:
  `getImplementedProtocols` in class `SSLUtilBase`

### getImplementedCiphers

protected Set<String> getImplementedCiphers()

Specified by:
  `getImplementedCiphers` in class `SSLUtilBase`

### isTls13RenegAuthAvailable

protected boolean isTls13RenegAuthAvailable()

Specified by:
  `isTls13RenegAuthAvailable` in class `SSLUtilBase`

### createSSLContextInternal

public SSLContext createSSLContextInternal(List<String> negotiableProtocols) throws Exception

Specified by:
  `createSSLContextInternal` in class `SSLUtilBase`
Throws:
  `Exception`

### chooseKeyManager

public static X509KeyManager chooseKeyManager(KeyManager[] managers, boolean throwOnMissing) throws Exception

Throws:
  `Exception`

### getKeyManagers

public KeyManager[] getKeyManagers() throws Exception

Specified by:
  `getKeyManagers` in interface `SSLUtil`
Overrides:
  `getKeyManagers` in class `SSLUtilBase`
Throws:
  `Exception`